<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.monitor.web.user.actions.*" %>
<%@ page import="com.sas.oprisk.monitor.web.cpb.runtime.component.*" %>
<%@ page import="com.sas.oprisk.server.web.cpb.runtime.MonitorUIContext"%>
<%@ page import="com.sas.services.security.SecurityUtil"%>
<%@ include file="/tiles/taglibs.jsp" %>
<%
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
   ConfidentialUsersChooserModel model = ConfidentialUsersChooserComponent.getModel(request);

   PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   User user = SecurityUtils.getUser(psession);
   
   String taggedPointerHandle = model.confidentialObject == null ? "" 
      : model.confidentialObject.getTaggedPointerHandle().toString();
%>
<mon:include js="/dwr/engine.js" />
<mon:include js="/dwr/util.js" />
<mon:include js="/dwr/interface/CommonService.js" />

<script type="text/javascript">
   var ConfidentialUsers = {};

   ConfidentialUsers.getForm = function()
   {
      return document.forms[0];
   }
   
   ConfidentialUsers.getTableParameters = function()
   {
      return getParamsForTable(ConfidentialUsers.getForm(), "confidentialUsers");
   }
   
   ConfidentialUsers.deleteUser = function(userRk)
   {
      if (userRk == <%=user.getUserRk()%>)
      {
          alert("<fmt:message key="confidentiality.cannotRemoveYourself.txt" />");
          return;
      }
      
      CommonService.deleteConfidentialUser(
            userRk, "<%= taggedPointerHandle %>",
            ConfidentialUsers.getTableParameters(),
            ConfidentialUsers.handlePageModification
         );
   }
   
   ConfidentialUsers.handleAddUser = function(userHandle)
   {
      CommonService.addConfidentialUser(
            userHandle,
            "<%= taggedPointerHandle %>",
            ConfidentialUsers.getTableParameters(),
            ConfidentialUsers.handlePageModification
         );
   }
   
   ConfidentialUsers.addUser = function()
   {
      var url = '<%=request.getContextPath()%>/ConfidentialUserChooserQuery.do' +
                '?method=ConfidentialUsers.handleAddUser&showSuperUsers=true&allowClear=false';
<%
   if (model.varDefinition != null) {   // from preview
      if (model.varDefinition.getSecureAction() != null)
      {
%>
      url += '&secureAction=<%=model.varDefinition.getSecureAction().value%>'; 
<%
      }

      if (model.secureObjectClass != null)
      {
%>
      url += '&secureObjectClass=<%=model.secureObjectClass.getName()%>'; 
<%
      }
   
      String locationVarName = model.varDefinition.getLocationFieldName();
      if (locationVarName != null)
      {
%>
      var form = ConfidentialUsers.getForm();
      var locationField = form.elements["<%=locationVarName%>"];

      if (locationField)
      {
         url += '&location=' + locationField.value;
      }<%
         if (model.initialLocation != null)
         {
%>
      else
      {
         url += '&location=<%=model.initialLocation.getHandleString()%>';
      }
<%
         }
      }
   }
%>
      openModal(url, 'confidentialUserPopup', 'width=750,height=500,scrollbars,resizable');
   }
   
   ConfidentialUsers.refresh = function()
   {
      CommonService.refreshConfidentialUsers(
            "<%= taggedPointerHandle %>",
            ConfidentialUsers.getTableParameters(),
            ConfidentialUsers.handlePageModification
         );
   }
   
   ConfidentialUsers.handlePageModification = function(pageModification)
   {
      if (pageModification)
      {
         PageModification.handle("confidentialUsers", pageModification);
      }
   }
</script>

<div id="confidentialUsers" style="font-weight: normal; margin-top: .5em;">
   <jsp:include page="ConfidentialUsersChooserTable.jsp" />
</div>

<script type="text/javascript">
   // override the submit function to use ajax
   getTableComponent("confidentialUsers_").submit = function() {
      ConfidentialUsers.refresh();      
   };
</script>