<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>

<%--
/**
 * This is the static javascript used by OraEditor.jsp.
 * instead of a jsp include, so that the browser will (hopefully) cache it.
 */
--%>

<%@ include file="/tiles/taglibs.jsp" %>
<%
	java.util.ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
%>

// add a method to remove an element
new Array(); 
Array.prototype.remove = function(index) { 
	if (index >= this.length) return; 
	if (index == this.length-1) {this.length-=1; return;} 
	for (var i=index+1; i<this.length; i++) this[i-1] = this[i]; 
	this.length -= 1; 
}

function oraEscape(text) {
   try {
      var div = document.createElement("div");
      div.appendChild(document.createTextNode(text));
      return div.innerHTML;
   } catch(e) {
      return "";
   }
}

function oraForm() {
	return document.forms.oraForm;
}

function doSearch() {
	if (isDimPoint) {
		window.frames.treeChooserFrame.setSelectedValue_search();
	} else {
		window.frames.treeChooserFrame.setSelectedValue_search("forward=SearchDimTree");
  	}
}

function doHideInactive(hide) {
	if (window.frames.treeChooserFrame.setSelectedValue_filter) {
		window.frames.treeChooserFrame.setSelectedValue_filter(!hide);
	} else {
		refreshSelectionArea(true);
	}
}

function doAdd() {
	var form = oraForm();
	form.addButton.disabled = true;
	var result = true;
   
	if (isTreeView()) {	// add the one selected node
		result = addDimNode(form.selectedValue.value, form.selectedValueLabel.value,
			form.selectedValuePath.value);
	} else {	// add all selected nodes
		var form = window.frames.treeChooserFrame.document.forms.nodeList;
		
		var cbs = getCheckboxArray(form, "resultHandle");
		var selHandles = new Array();
		var selPaths = new Array();
		for (var i = 0; i < cbs.length; i++) {
			if (cbs[i].checked) {
				selHandles[selHandles.length] = cbs[i].value;
				selPaths[selPaths.length] = 
					unescape(window.frames.treeChooserFrame.paths[i]);
				cbs[i].checked = false;
			}
		}
		form.selectAll.checked = false;
		
		var errorMsg = doAddFromSearch(selHandles, selPaths);
		if (errorMsg != null) {
			alert(errorMsg);
			result = false;
		}
	}
	
	return result;
}

function addDimNode(id, name, path, failQuietly) {
	var form = oraForm();
	var dimSelect = form.dim;
	var dimIdx = dimSelect[dimSelect.selectedIndex].value;
	var dim = dims[dimIdx];

	var msg = checkDimInUse(dim, true);
	if (msg != null) {
		if (!failQuietly) {
			alert(msg);
			return false;
		}
	}
	
	// quietly fail if node is already there
	if (isNodeInUse(dim, id)) {
		return true;
	}

	if (path == "") {
		path = name;
	}

	var dimNode = new DimensionNode(dim, id, formatPath(path));
	dimNodes[dimNodes.length] = dimNode;
	dimsInUse[dim.name] = true;

	addDimTableRow(dimNode);
	scrollDimNodesToBottom();
	updateDimTableButtons();
	if (isDimPoint) {
		clearTree();
  	} else {
		setSelectedValue("", "", "", "");
  	}
	refreshDimSelector(false);
	return true;
}

function doAddFromSearch(handles, paths) {
	var form = oraForm();
	var dimSelect = form.dim;
	var dimIdx = dimSelect[dimSelect.selectedIndex].value;
	var dim = dims[dimIdx];
	
	var errorMsg = checkDimInUse(dim, true);
	if (errorMsg != null) {
		return errorMsg;
	}

	for (var i = 0; i < handles.length; i++) {
		if (!isNodeInUse(dim, handles[i])) {
			var dimNode = new DimensionNode(dim, handles[i], paths[i]);
			dimNodes[dimNodes.length] = dimNode;
		
			addDimTableRow(dimNode);
		}
	}
	scrollDimNodesToBottom();
	dimsInUse[dim.name] = true;
	updateDimTableButtons();
	refreshDimSelector(false);
}

function scrollDimNodesToBottom() {
	var div = elementById('nodeDiv');
	div.scrollTop = div.scrollHeight - div.clientHeight;
}

function formatPath(path) {
	if (path.charAt(path.length-1) == '|') {
		path = path.substring(0, path.length-1);
	}
	return path.replace(/\|/g, ' > ');
}

function getNodeDescription(dimNode) {
	return dimNode.dim.label + ": " + dimNode.path;
}

function doUpdate() {
	var form = oraForm();
	if (currentDimRow != null) {
		var idx = currentDimRow.rowIndex;
   	
		var dimSelect = form.dim;
		var dimIdx = dimSelect[dimSelect.selectedIndex].value;
		var dim = dims[dimIdx];
		
		var dimNode = new DimensionNode(dim, form.selectedValue.value, 
			formatPath(form.selectedValuePath.value));

		if (dimNodes[idx].dim.name != dim.name && checkDimInUse(dim)) {
			return false;
		}
		
		dimNodes[idx] = dimNode;
	
      currentDimRow.childNodes[0].innerHTML = oraEscape(dimNode.dim.label + ":");
      currentDimRow.childNodes[1].innerHTML = oraEscape((dimNode.path == "")
         ? form.selectedValueLabel.value : dimNode.path);
	}
	clearTree();
	refreshDimSelector();
	editing = false;
	return true;
}

function doEdit() {
   if (currentDimRow != null) {
		var form = oraForm();
		var idx = currentDimRow.rowIndex;
		var dimNode = dimNodes[idx];
		var dim = dimNode.dim;
		var dimSelect = form.dim;
		
		if (isDimLocked(dim)) {
		  	var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
					"ora.cannotEditLockedDim.fmt.txt")) %>");
			alert(formatMessage(msg, dim.label + ": " + dimNodes[idx].path));
			return;
		}
   
		if (!isTreeView()) {
			selectRadio(form, "view", "tree");
		}

		for (var i = 0; i < dimSelect.options.length; i++) {
			if (dims[i].name == dim.name) {
				dimSelect.selectedIndex = i+1;
				dimSelected(dimNode.nodeId, true, true);
				break;
			}
		}
	   //form.updateButton.disabled = false;
		editing = true;
	}
}

function doDelete() {
	if (currentDimRow != null) {
		var idx = currentDimRow.rowIndex;
		var dim = dimNodes[idx].dim;
		if (isDimLocked(dim)) {
		  	var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
					"ora.cannotDeleteLockedDim.fmt.txt")) %>");
			alert(formatMessage(msg, dim.label + ": " + dimNodes[idx].path));
			return;
		}
		if (isDimPoint) {
			dimsInUse[dim.name] = false;
		}
		dimNodes.remove(idx);	// remove the element at idx
	   	
		var tbody = currentDimRow.parentNode;
		tbody.deleteRow(idx);
		currentDimRow = null;
	   	
      editing = false;
		updateDimTableButtons();
		refreshDimSelector();
	}
}

function doClear(checkLocked) {
	if (checkLocked) {
		for (var i = 0; i < dimNodes.length; i++) {
			var dim = dimNodes[i].dim;
			if (isDimLocked(dim)) {
			  	var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
						"ora.cannotDeleteLockedDim.fmt.txt")) %>");
				alert(formatMessage(msg, dim.label + ": " + dimNodes[i].path));
				return;
			}
		}
	}

	var tbody = document.getElementById("dimTable");
	while (tbody.rows.length > 0) {
		tbody.deleteRow(0);
	}

	dimNodes = new Array();
	currentDimRow = null;
   editing = false;
	updateDimTableButtons();
	refreshDimSelector();
}

function isDimMatch()  {
   var form = oraForm();
   if( currentDimRow != null) {
      var idx = currentDimRow.rowIndex;
      var dimSelect = form.dim;
      var dimIdx = dimSelect[dimSelect.selectedIndex].value;
      var dim = dims[dimIdx];
      return (dimNodes[idx].dim.name === dim.name);
   }
   return false;
}

function doOk(target, closeWindow, overrideLock) {
   var form = oraForm();
   form.target = (typeof(target) == 'undefined') ? window.name : target;
   form.close.value = (typeof(closeWindow) == 'undefined') ? true : closeWindow;
      
	// also do "Update" if currently in edit mode
	if (!form.updateButton.disabled) {
      if (isDimMatch()) { //do an update if the dimension matches, else we add a new node.
         if (!doUpdate()) {  // if update fails, don't close dialog
            return;
         }
      } else {
         if (!doAdd()) {  // if add fails, don't close dialog
            return;
         }
      }
	}
	// also do "Add" if items are currently selected
	else if (!form.addButton.disabled) {
		if (!doAdd()) {	// if add fails, don't close dialog
			return;
		}
	}

	// make sure all required dims have been selected
	var dimErrors = "";
	if (!isForFiltering) {
		for (var i = 0; i < dims.length; i++) {
			if (dims[i].required && !isDimInUse(dims[i])) {
				dimErrors += "\n    " + dims[i].label;
			}
		}
	}
	if ("" != dimErrors) {
	  	var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
				"ora.dimensionsRequired.fmt.txt")) %>");
        alert(formatMessage(msg, dimErrors));
		return;
	}

   if(!overrideLock) {
      lock(document.getElementById("actionButtonOk")); // disable to keep user from re-clicking
   }
   
   form.nodes.value = getNodesAsString();
	form.submit();
}

function doAddPoint() {
   var form = oraForm();
   doOk('oraFrame', false, true);
}

function getNodesAsString() {
	var nodes = "";
	for (var i = 0; i < dimNodes.length; i++) {
		nodes += dimNodes[i].nodeId + ";";
	}
	return nodes;
}

function doCancel() {
	if (isFavorite) {
	   var form = oraForm();
	   form.action = "<%= request.getContextPath() %>/Ora.do?method=manageFavorites";
	   form.submit();
	} else {
		window.close();
	}
}

function doEverywhere() {
   var form = oraForm();	
   form.nodes.value = "everywhere";
	form.submit();
}

function clearTree() {
   var form = oraForm();	
   
	var dimSelect = form.dim;
	dimSelect.selectedIndex = 0;

	dimSelected();
}

function dimSelected(nodeId, disableAddButton, forceVisible, saveFilter) {
	var select = oraForm().dim;
	var dimIdx = select[select.selectedIndex].value;
	var url = "<%= request.getContextPath() %>/blank.html";
	var itemSelected = false;
	var form = oraForm();	
	form.addButton.disabled = (typeof(disableAddButton ) == "undefined") ? true : disableAddButton;
	var selectedId = (nodeId && nodeId != "") ? nodeId : "";
	form.selectedValue.value = selectedId;
	if (dimIdx != "") {
		var dim = dims[dimIdx];
		if (dim.nodeClass != null) {
			if (isTreeView()) {
				url = "<%= request.getContextPath() %>" +
					"/Ora.do?method=viewTreeChooser" 
				if (nodeId && nodeId != "") {
					url += "&selectedValue=" + nodeId;
				} else {
               form.updateButton.disabled = true;
            }
				if (forceVisible) {
					url += "&fv=" + forceVisible;
				}
			} else {
				url = "<%= request.getContextPath() %>/DimNode.do?method=list" 
				if (!isDimPoint && (isForFiltering || dim.multiselectAllowed)) {
					url += "&multiselect=true";
				}
				window.frames.treeChooserFrame.setTimeout(showPleaseWait, 1000);
			}
			if (isConstrained()) {
				url += "&parentArea=" + parentArea
					+ "&constrain=true"
					+ "&nodes=" + getNodesAsString();
			}
			if (saveFilter) {
				url += "&sf=true";
			}
			url += "&dimensionNodeClassName=" + dim.nodeClass
				+ "&showRoot=" + isRootVisible
				+ "&feature=" + feature
				+ "&secureObjectClass=" + secureObjectClass
				+ "&secureAction=" + secureAction
				+ "&showInactive=" + (!form.hideInactive.checked)
				+ "&leafOnly=" + dim.leafOnly;
			itemSelected = true;
		}
	} else {
		if (saveFilter) {
			url = "<%= request.getContextPath() %>/Ora.do?method=saveFilter"
				+ "&showInactive=" + (!form.hideInactive.checked);
		}
		form.selectedValue.value = "";
		form.updateButton.disabled = true;
	}
	
	form.searchButton.disabled = !itemSelected;
	updateDimTableButtons();

   viewUrl(url, window.frames.treeChooserFrame);
}

function showPleaseWait() {
   window.frames.treeChooserFrame.document.body.innerHTML = "<div><fmt:message key='application.wait.txt' /></div>";
}

function dimNodeSelected(e) {
   if (e == undefined) {
      // needed for IE
      e = window.event;
   }

   var td = e.target ? e.target : e.srcElement;;
   
   // should get back the td element
   while(td.nodeName.toLowerCase() != "td")
   {
      td = td.parentNode;
   }
   
   // get back to the row
   var tr = td.parentNode;

   if ((currentDimRow != null) && (tr.rowIndex != currentDimRow.rowIndex)) {
      // deselect the currently selected row
      currentDimRow.className = "";
	}
	
   if (tr != null) {
      tr.className = "selectedRow";
	}
	
	currentDimRow = tr;
	
   var form = oraForm();	
   form.updateButton.disabled = true;
   editing = false;
	updateDimTableButtons();
   //clearTree();
}

function setTableRowColor(row, bgcolor, textcolor)  {
   row.setAttribute("bgColor",bgcolor);
   // have to set color on cells
   for (var i = 0; i < row.childNodes.length; i++) {
      row.childNodes[i].style.color=textcolor;
   }
}

function updateDimTableButtons()  {
   var form = oraForm();	
   form.editButton.disabled = currentDimRow == null;
   form.deleteButton.disabled = currentDimRow == null;
   form.clearButton.disabled = (dims.length == 0);
}

function addDimTableRow(dimNode) {

   var nodeAnchor = document.createElement("a");
   nodeAnchor.innerHTML = oraEscape(dimNode.path);
   nodeAnchor.href = "javascript: ;";
   nodeAnchor.onclick = dimNodeSelected;
   
   var tr = document.createElement("tr");
   tr.className = "selected";

   var td = document.createElement("td");
   td.className = "nodeLabel";
   td.appendChild(document.createTextNode(dimNode.dim.label + ":"));
   tr.appendChild(td);
      
   td = document.createElement("td");
   td.className = "nodeValue";
   td.appendChild(nodeAnchor);
   tr.appendChild(td);
      
   tr.onclick = dimNodeSelected;
   
   var dimTable = document.getElementById("dimTable");
   dimTable.appendChild(tr);
   
   return tr;
}

function setSelectedValue(id, name, node, locPath) {
   var form = oraForm();
   
   form.selectedValue.value = id;
   form.selectedValueLabel.value = name;
   form.selectedValuePath.value = locPath;
   
   form.addButton.disabled = (id == "");
   form.updateButton.disabled = (id == "") || !editing;
}

function fillDimSelector() {
	var select = oraForm().dim;
	select.options.length = 0;
	select.options[0] = new Option("< <fmt:message key='ora.selectDimension.item.txt'/> >", "");
	for (var i = 0, x = 1; i < dims.length; i++, x++) {
		select.options[x] = new Option(
			((!isForFiltering && dims[i].required) ? "* " : "") + dims[i].label, i);
		if (typeof(editDim) != 'undefined' && dims[i].name == editDim) {
			select.selectedIndex = x;
		}
	}
	if (dims.length == 1) {
		select.selectedIndex = 1;
	}
}

function refreshDimSelector(refreshSelArea) {
	var options = oraForm().dim.options;
	for (var i = 0; i < dims.length; i++) {
		var enabled = 
			!((isDimPoint || !(isForFiltering || dims[i].multiselectAllowed)) && isDimInUse(dims[i]));
			
		if(!enabled){
         options[i+1].style.color = "#AAAAAA";
      }
	}
   if (typeof(refreshSelArea) == 'undefined') {
      refreshSelArea = true;
   }
	if (isConstrained() && refreshSelArea) {
		refreshSelectionArea();
	}
}

function checkDimInUse(dim, returnMessage) {
	if ((isDimPoint || !(isForFiltering || dim.multiselectAllowed)) && isDimInUse(dim)) {
		var msg;
		if (isDimLockedAndUnselected(dim)) {	// special message
	  		msg = unescape("<%= ParsingUtils.escape(bundle.getString(
				"ora.cannotAddLockedDim.txt")) %>");
		} else {
	  		msg = formatMessage(unescape("<%= ParsingUtils.escape(bundle.getString(
				"ora.dimensionInUse.fmt.txt")) %>"), dim.label);
		}
		if (returnMessage) {
			return msg;
		}
		alert(msg);
		return true;
	}
	return returnMessage ? null : false;
}

function isDimLocked(dim) {
	return typeof(lockedDims[dim.name]) != 'undefined';
}

function isDimLockedAndUnselected(dim) {
	return lockedDims[dim.name] == false;
}

function isDimInUse(dim) {
	// first check dims that are locked by a previous point
	if (isDimLocked(dim)) {
		return true;
	}
	
	for (var i = 0; i < dimNodes.length; i++) {
		if (dim.name == dimNodes[i].dim.name) {
			return true;
		}
	}
	return false;
}

function isNodeInUse(dim, nodeId) {
	for (var i = 0; i < dimNodes.length; i++) {
		if ((dim.name == dimNodes[i].dim.name) &&
			 (nodeId == dimNodes[i].nodeId))
		{
			return true;
		}
	}
	return false;
}

function getDimensionByName(name) {
	for (var i = 0; i < dims.length; i++) {
		if (dims[i].name == name) {
			return dims[i];
		}
	}
	return null;
}

function getSelectedHandle(dimName) {
	for (var i = 0; i < dimNodes.length; i++) {
		if (dimName == dimNodes[i].dim.name) {
			return dimNodes[i].nodeId;
		}
	}
	return null;
}

function setTreeView(tree) {
   var form = oraForm();
   
   form.addButton.disabled = true;
   if (!tree) {
	   form.updateButton.disabled = true;
	   editing = false;
   }
   
	dimSelected();
}

function isTreeView() {
   return "tree" == getSelectedRadioValue(oraForm(), "view");
}

function refreshSelectionArea(saveFilter) {
	var form = oraForm();
	dimSelected(form.selectedValue.value, (form.selectedValue.value == ""), false, saveFilter);
}

function isConstrained() {
   return "true" == getSelectedRadioValue(oraForm(), "constrained");
}

/* Shows a list of favorite locations */
function showFavorites() {
	var menu = new TableMenu();
	for (var i = 0; i < favs.length; i++) {
		var fav = favs[i];
		menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<%= request.getContextPath() %>/<fmt:message key='application.favorite.image'/>", fav.name, "javascript:selectFavorite('" + fav.handle + "')", fav.enabled));
	}
	menu.render();
	return false;
}

function selectFavorite(handle) {
	doClear(false);
	var oraFrame = window.frames['oraFrame'];
	oraFrame.location.href = "Ora.do?method=selectFavoriteToEdit&dpHandle=" + handle;
}

function Dimension(label, name, nodeClass, multiselectAllowed, required, leafOnly) {
	this.label = label;
	this.name = name;
	this.nodeClass = nodeClass;
	this.multiselectAllowed = multiselectAllowed;
	this.required = required;
	this.leafOnly = leafOnly;
}

var dimNum = 0;
function DimensionNode(dim, nodeId, path) {
	this.num = dimNum++;
	this.dim = dim;
	this.nodeId = nodeId;
	this.path = path;
}

var dimNodes = new Array();
var dimsInUse = new Array();
var currentDimRow = null;
var editing = false;
