<%@ page import="com.sas.oprisk.monitor.web.tags.treechooser.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%
   java.util.ResourceBundle bundle = ApplicationProperties.getBundle(request.getLocale());
    PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   SearchTreeForm form = (SearchTreeForm)pageContext.findAttribute("searchTreeForm");
   boolean multiselect = "true".equals(request.getParameter("multiselect"));
   String selectButtonKey = request.getParameter("selectButtonKey");
   String winPath = request.getParameter("winPath");
   if (winPath == null || winPath.length() == 0) {
      winPath = "";
   } else {
      // Make sure it can't contain invalid characters
      winPath = "." + StringUtil.makeValidJSObjectPath(winPath);
   }
%>

<mon:Page template="popup">
   <mon:Head>
      <script type="text/javascript">
      function monitorInit() {
         document.forms.searchTreeForm.searchText.focus();
      }
      
      function selectResult(id, name, node, locPath) {
         if (window.opener) {
            var chooserFrame = window.opener<%= winPath %>.frames["treeChooser" + "<%= StringUtil.escapeJSForHTML(form.getTreeName()) %>"];
            chooserFrame.select("<%=StringUtil.escapeJSForHTML( form.getSelectMethod()) %>", id, name, node, locPath, alertCallback);
            window.close();
         }
      }
      
      /* This method is here so that an alert can be displayed from the correct window. */
      function alertCallback(msg) {
         alert(msg);
      }
      
      var paths = new Array();

      <mon:include js="/script/checkboxRadioUtil.js" />
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/SearchTree.do?method=search">      
         <mon:Content>
            <html:hidden property="method"/>
            <html:hidden property="selectMethod"/>
            <html:hidden property="dimensionNodeClassName"/>
            <html:hidden property="showDescendantsOfConstrainedObjects"/>
            <html:hidden property="showInactive"/>
            <html:hidden property="showRoot"/>
            <html:hidden property="leafOnly"/>
            <html:hidden property="nonLeafOnly"/>
            <html:hidden property="treeName"/>
            <html:hidden property="forward"/>
            <html:hidden property="winPath"/>
            <html:hidden property="constrain"/>
            
            <html:hidden property="secureObjectClass"/>
            <html:hidden property="secureAction"/>
            <html:hidden property="previouslySelectedNodes"/>
            <html:hidden property="parentArea"/>
            <html:hidden property="feature"/>
         
         <div style="width: 300px;">
         
            <div class="fieldlabel">
               <label for="searchText">
                  <fmt:message key="application.searchText.txt" />:
               </label>
            </div>
            
            <input name="searchText" id="searchText" style="width: 100%;" />                        
            
         </div>
         
         <%
            java.util.List results = (java.util.List)request.getAttribute("results");
            if (results != null) {
         %>
         <br />
         
         <c:if test="${resultsTruncated}">
         <table><tr><td><img src="<%= request.getContextPath() %>/<fmt:message key='application.informSmall.image'/>"></td>
            <td class="infoMessage"><fmt:message key="application.searchResults.truncated.txt" /></td>
         </tr></table>
         <br />
         </c:if>
         
         <%
            String selColTitle = "<input type=\"checkbox\" name=\"selectAll\" title=\"" 
               + bundle.getString("application.selectAll.tooltip.txt") + "\" />";
         %>
         
         <mon:table name="results" class="displayTable" id="node" cellspacing="0" style="width: 100%;">
            <mon:title><fmt:message key="application.searchResults.txt" /></mon:title>
         <% if (multiselect) { %>
            <mon:action href="javascript:selectResults()"><%= bundle.getString(selectButtonKey) %></mon:action>
         <% } %>
            
         <%
            SubtreeCodec treeNode = (SubtreeCodec)node;
               if (treeNode != null) {
                  String id = treeNode.getId();
                  // double escape name and path because they are going in an href
                  String escName = ParsingUtils.escape(treeNode.getName());
                  String escPath = ParsingUtils.escape(treeNode.getAbsolutePath());
                  
                  // localized path
                  String locPath = com.sas.oprisk.server.util.PathUtils.formatPath(
                        treeNode.getLocalizedPath(psession));
                  String escLocPath = ParsingUtils.escape(locPath);
         %>
         <% if (multiselect) { %>
            <display:column width='1%' title="<%= selColTitle %>">
               <input type="checkbox" name="resultHandle" value="<%= id %>" />
               <script type="text/javascript">paths[paths.length] = "<%= "".equals(escLocPath) ? escName : escLocPath %>";</script>
            </display:column>
         <% } %>
         
            <display:column title='<%= bundle.getString("application.name.txt") %>'>
              <a href="#" onclick="selectResult('<%= StringUtil.escapeJSForHTMLAttribute(id) %>', '<%= escName %>', '<%= escPath %>', '<%= escLocPath %>')"
              ><c:out value='${node.name}' /></a>
            </display:column>
            <display:column title='<%= bundle.getString("DimensionView.path.label.txt") %>'>
              <a href="#" onclick="selectResult('<%= StringUtil.escapeJSForHTMLAttribute(id) %>', '<%= escName %>', '<%= escPath %>', '<%= escLocPath %>')"
              ><%= StringUtil.escapeHTML(locPath) %></a>
            </display:column>
         <%    }  %>
         </mon:table>
         
         <%    if (multiselect) { %>
         <script type="text/javascript">
         new CheckboxGroup("searchTreeForm", "resultHandle", "selectAll");
         </script>
         <%    } %>
         <% } %>
         </mon:Content>   
         
         <mon:PopupButtonBar>
            <mon:Button name="search" onclick="lock(this);submit()">
               <fmt:message key="application.search.txt" />
            </mon:Button>
            
            <mon:Button name="cancel" onclick="window.close()">
               <fmt:message key='cancelButton.txt' />
            </mon:Button>               
         </mon:PopupButtonBar>
      </html:form>      
   </mon:Body>
</mon:Page>