<%@page import="com.sas.oprisk.monitor.web.table.TableCellFormatter"%>
<%@page import="com.sas.oprisk.monitor.web.table.AssetRiskProfileCellFormatter"%>
<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.csa.RCSAGeneralModel" %>
<%@ page import="com.sas.oprisk.server.base.AssessmentStatusCd" %>
<%@ page import="com.sas.oprisk.server.AssessmentEx" %>

<%@ include file="/tiles/taglibs.jsp" %>

<%
try {    
   final Locale locale = request.getLocale();
   final ResourceBundle bundle = ApplicationProperties.getBundle(locale);
   final PersistenceSession psession = MonitorContext.getPersistenceSession(request);
   final User currentUser = SecurityUtils.getUser(psession);
   
   final MonitorContext monitorContext = MonitorContext.getMonitorContext(request);
   HashMap<String, TableCellFormatter> colFormatters =  new HashMap<String, TableCellFormatter>();
   final AssetRiskProfileCellFormatter  riskProfileValueFormatter = new AssetRiskProfileCellFormatter(MonitorContext.getMonitorContext(request));
   colFormatters.put("assetRiskProfileRespVal", riskProfileValueFormatter);
      
   boolean changeReasonRequired = ConfigDataProperties.isChangeReasonRequired();
   String deleteConfirmMsg = ParsingUtils.escape(bundle.getString("Assessments.delete.confirm.message.fmt.txt"));
     
%>

<mon:Page template="default">
   <mon:Head>
      <script type="text/javascript">

      function setDimAreaHandle(daHandle) {
         beginWait();
         document.forms.queryForm.submit();
         return false;
      }
      
      function showCreateMenu() {
         var menu = new TableMenu();
         
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= request.getContextPath() %>/<fmt:message key='application.newAssessment.image'/>", 
            "<fmt:message key='Assessments.button.createFormBased.txt'/>", 
            "javascript:createAssessment(true)", true));
         
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
               "<%= request.getContextPath() %>/<fmt:message key='application.newAssessment.image'/>", 
               "<fmt:message key='Assessments.button.createQnrBased.txt'/>", 
               "javascript:createCpbAssessment()", true));
         
         menu.render();
         return false;
      }

      function createCpbAssessment() {
         var f = document.forms.queryForm;
         f.action = "<%= request.getContextPath() %>/"
            + "QuestionnaireAssessment.do?method=create"; 
         f.location.value = f.TCArea.value;
         f.submit();
      }
      
      function createAssessment(formBased) {
         if (formBased == undefined) {
            formBased = <%= ConfigDataProperties.isRcsaFormBasedAssessmentsEnabled() %>;
         } 
         var f = document.forms.queryForm;
         f.action = "<%= request.getContextPath() %>/"
            + (formBased ? "Assessment.do" : "QuestionnaireAssessment.do") 
            + "?method=create";
               
         f.location.value = f.TCArea.value;
         f.submit();
      }
      
      function createAssessmentFrom(handle) {
         document.forms.queryForm.action =
            "<%= request.getContextPath() %>/QuestionnaireAssessment.do"
               + "?method=createFrom"
               + "&handle=" + handle;
         document.forms.queryForm.submit();
      }
      
      function deleteAssessment(handle) {
         goAssessment("delete", handle);
      }
      
      function deleteAssessment(handle, name) {
        <% if (!changeReasonRequired) { %>
           var msg = formatMessage(
               unescape('<%= deleteConfirmMsg %>'), 
               unescape(name)
               );
           if (!confirm(msg)) {
              return;
           }
        <% } %>
        goAssessment("delete", handle);
      }
      
      function cancelAssessment(handle) {
         goAssessment("cancel", handle);
      }
      
      function goAssessment(method, handle, showWaitDialog) {
         if (showWaitDialog) {
            beginWait();
         }
         document.forms.queryForm.action =
            "<%= request.getContextPath() %>/Assessments.do"
               + "?method=" + method
               + "&handle=" + handle;
         document.forms.queryForm.submit();
      }
      
      function doQbaAssessment(method, handle, showWaitDialog) {
         if (showWaitDialog) {
            beginWait();
         }
         document.forms.queryForm.action =
            "<%= request.getContextPath() %>/AssessmentWizard.do"
               + "?method=" + method
               + "&handle=" + handle
               + "&useWizardForQBA=true";
         document.forms.queryForm.submit();
      }
      
      function showContextMenu(handle, statusCd, name, hasTemplate, formBased, canCancel, canCreateNewFrom) {
         var nyo = '<%= AssessmentStatusCd.notYetOpen.getValue() %>' == statusCd;
         var open = '<%= AssessmentStatusCd.open.getValue() %>' == statusCd;
         var closed = '<%= AssessmentStatusCd.closed.getValue() %>' == statusCd;
         var cancelled = '<%= AssessmentStatusCd.cancelled.getValue() %>' == statusCd;
         
         var menu = new TableMenu();

      <c:if test="${canUpdate}">
         if (!formBased) {
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
               "<%= request.getContextPath() %>/" + (nyo ? "<fmt:message key='Assessments.open.image'/>" : "<fmt:message key='Assessments.disabled.image'/>"), 
               "<fmt:message key='Assessments.button.open.txt'/>", "javascript:goAssessment('prepareToOpen', '" + handle + "')", 
               nyo));
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
               "<%= request.getContextPath() %>/" + (open ? "<fmt:message key='Assessments.close.image'/>" : "<fmt:message key='Assessments.disabled.image'/>"), 
               "<fmt:message key='Assessments.button.close.txt'/>", "javascript:goAssessment('close', '" + handle + "', true)", 
               open));
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
               "<%= request.getContextPath() %>/" + (closed ? "<fmt:message key='Assessments.reopen.image'/>" : "<fmt:message key='Assessments.disabled.image'/>"), 
               "<fmt:message key='Assessments.button.reopen.txt'/>", "javascript:goAssessment('reopen', '" + handle + "')", 
               closed));
            menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));
         }
      </c:if>
      
      <c:if test="${canCreate}">
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
            "<%= request.getContextPath() %>/" +
               ((canCreateNewFrom && (closed || !formBased))  
                  ? "<fmt:message key='application.createNewFrom.image'/>"
                  : "<fmt:message key='application.createNewFrom.disabled.image'/>"), 
            "<fmt:message key='Assessments.button.createNewFrom.txt'/>", 
            "javascript:createAssessmentFrom('" + handle + "')",
            canCreateNewFrom && (closed || !formBased)));
      </c:if>
      <c:if test="${canUpdate}">
         if (formBased) {
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action,
               "<%= request.getContextPath() %>/" + ((!closed && canCancel && !cancelled) ? "<fmt:message key='Assessments.close.image'/>" : "<fmt:message key='Assessments.disabled.image'/>"), 
               "<fmt:message key='Assessments.button.cancel.txt'/>", "javascript:goAssessment('cancelAssessment', '" + handle + "', true)", 
               !closed && canCancel && !cancelled));
         }
      </c:if>
      <c:if test="${canDelete}">
         menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));
         menu.addMenuItem(new MenuItem(MenuItem.prototype.action, 
            "<%= request.getContextPath() %>/<fmt:message key='application.delete.image'/>", 
            "<fmt:message key='application.button.delete.txt'/>", 
            "javascript:deleteAssessment('" + handle + "', '" + name + "')"));
      </c:if>
         if (!formBased) {
      <c:if test="${canCreate or canDelete}">
            menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));
      </c:if>
            menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"<%= request.getContextPath() %>/<fmt:message key='Assessments.viewQuestionnaires.image'/>", "<fmt:message key='Assessments.button.viewQuestionnaires.txt'/>", "javascript:goAssessment('viewQuestionnaires', '" + handle + "')"));
         }
         
         menu.render();
         return false;
      }
      
      
      </script>
   </mon:Head>
   <mon:Body>      
      <html:form action="/AssessmentQuery">      
         <mon:ToolBar>
            <c:if test="${canCreate}">
               <% if (ConfigDataProperties.isRcsaFormBasedAssessmentsEnabled() && ConfigDataProperties.isRcsaQnrBasedAssessmentsEnabled()) {  %> 
                  <a class="dropDownArrow toolBarAction" href="#" onclick="showCreateMenu(); return false;" >
                     <fmt:message key='Assessments.button.create.dropdown.txt'/>&nbsp;
                  </a>
               <% } else if (ConfigDataProperties.isRcsaFormBasedAssessmentsEnabled() || ConfigDataProperties.isRcsaQnrBasedAssessmentsEnabled()) {  %>
                  <a class="toolBarAction" href="#" onclick="createAssessment(); return false;">
                     <fmt:message key='Assessments.button.new.txt'/>
                  </a>
               <% } %>
            </c:if>
            <mon:SavedView />
         </mon:ToolBar>
         
         <mon:Content>
            <mon:tableComponent id="assessment" disableTableActions="true" columnFormatters="<%=colFormatters %>" >
            
            <c:if test="${canCreate || canUpdate || canDelete}" >
               <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
            <%
               final AssessmentEx assessment = (AssessmentEx)pageContext.findAttribute("assessment");
               final String escName = ParsingUtils.escape(assessment.getName());
               final boolean canCancel = currentUser.isSuperUser(psession) || currentUser.equals(assessment.getOwner(psession));
			   final Boolean canCreateNewFromBool = assessment.getFormBasedFlg();
               final boolean canCreateNewFrom = (canCreateNewFromBool==null || canCreateNewFromBool.booleanValue())
                  ? true
                  : !assessment.getTemplateIsNull().booleanValue(); 
            %>
                  &nbsp;<a href="#" onclick="return showContextMenu('<c:out value='${assessment.handleString}'/>', '<c:out value='${assessment.assessmentStatusCd}'/>', '<%= escName %>', <c:out value='${!assessment.templateIsNull}'/>, <c:out value='${assessment.formBasedFlg}'/>, <%= canCancel %>, <%= canCreateNewFrom %>)"
                     ><img border="0"
                         src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                        alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                        title="<fmt:message key='application.rowActions.tooltip.txt'/>"
                  /></a>&nbsp;
               </mon:fixedColumn>
            </c:if>
         
         </mon:tableComponent>
         
         <input type="hidden" name="location" />
         </mon:Content>   
      </html:form>      
   </mon:Body>
</mon:Page>

<%
} catch (Exception e) {
	e.printStackTrace();
}
%>
