<%@ include file="/tiles/taglibs.jsp" %>

<%@ page import="java.util.*" %>
<%@ page import="com.sas.oprisk.framework.server.util.ParsingUtils" %>
<%@ page import="com.sas.oprisk.monitor.web.table.*" %>
<%@ page import="com.sas.solutions.cpb.web.util.RequestUtil" %>
<%@ page import="com.sas.oprisk.monitor.web.controlTesting.tests.*" %>
<%@ page import="com.sas.oprisk.monitor.web.controlTesting.testDefinitions.TestDefinitionsQueryAction" %>

<%    
     Locale locale = request.getLocale();
     ResourceBundle bundle = ApplicationProperties.getBundle(locale);
     PersistenceSession psession = MonitorContext.getPersistenceSession(request);
     
     MonitorContext mc = MonitorContext.getMonitorContext(request);
     java.util.Map formatters = new java.util.HashMap();
     formatters.put("activeFromDttm", new DateCellFormatter(mc));
     formatters.put("activeToDttm", new DateCellFormatter(mc));
     formatters.put("measures",   new TestMeasureCellFormatter(mc));
     formatters.put("validationStateCd", new WorkflowApproveStateFormatter(mc));
     
     boolean canCreateTestDefinitionGroup = SecurityUtils.canDoSomewhere(Do.CREATE, TestDefinitionGroup.object, psession);
     
     boolean canCreateTestDefinition = 
        SecurityUtils.canDoSomewhere(Do.CREATE, TestDefinition.object, psession) && 
        SecurityUtils.canDoSomewhere(Do.UPDATE, TestDefinition.object, psession);  // Need update permission for locking TD (LockableObjectImpl.java:288)
     boolean canDeleteTestDefinition = SecurityUtils.canDoSomewhere(Do.DELETE, TestDefinition.object, psession);
     boolean canCreateTest = SecurityUtils.canDoSomewhere(Do.CREATE, TestPlan.object, psession);
     
     boolean showContextMenu = canCreateTestDefinitionGroup || canDeleteTestDefinition || canCreateTestDefinition;
     
     Boolean invokedInAuditTab = TestDefinitionsQueryAction.invokedInAuditTab(request);
%>

<mon:Page template="default">
   <mon:Head>
      <mon:include js="/script/modalPopup.js" />
      
      <script type="text/javascript">
         function getForm() {
            return document.forms.queryForm;
         }     
         function createTestDefinition() {
            var f = getForm();
            f.action =
               "<%= request.getContextPath() %>/TestDefinitionEdit.do" 
               + "?method=create";
            <% if (invokedInAuditTab.booleanValue()){ %>
            f.action += "&auditTestDefn=true";
            <% } %>
            f.submit();
         }
            
         function deleteTestDefinition(handle, name) {
            var msg = unescape("<%= ParsingUtils.escape(bundle.getString(
                  "testDefinition.removeTestDefinition.confirm.message.fmt.txt")) %>");
            msg = formatMessage(msg, unescape(name));
            if (confirm(msg)) {
               doAction("delete", handle);
            }
         }     
      
         function createTestDefinitionGroup(handle) {
            var f = getForm();
            f.action =
               "<%= request.getContextPath() %>/TestDefinitionGroupEditor.do" 
               + "?method=createFromTestDefinition&handle=" + handle; 
            f.submit();
         }
      
         function doAction(method, handle) {
            beginWait();
            var f = getForm();
            f.action = "<%= request.getContextPath() %>/TestDefinitionEdit.do"
               + "?method=" + method
               + "&handle=" + handle;
            f.submit();
         }
         
         function createTests(handle){
            beginWait();
            var f = getForm();
            f.action = "<%= request.getContextPath() %>/CreateTests.do"
               + "?method=" + "createTestsFromTestDefinition"
               + "&handle=" + handle;
            f.submit();
         }
      
         function showContextMenu(handle, name, canCreateTestDefGroup, canCreateTestDefinition,canDelete) {
            var menu = new TableMenu();
      
            menu.addMenuItem(
              new MenuItem(MenuItem.prototype.action,
                  "<%= request.getContextPath() %>/" + "<fmt:message key='application.createNew.image'/>", 
                  "<fmt:message key='testDefinition.createTestGroup.menu.txt'/>", 
                  "javascript:createTestDefinitionGroup('" + handle + "')", 
                  (canCreateTestDefGroup == "true")));
      
            menu.addMenuItem(
               new MenuItem(MenuItem.prototype.action,
                   "<%= request.getContextPath() %>/" + "<fmt:message key='application.delete.image'/>", 
                   "<fmt:message key='application.delete.txt'/>", 
                   "javascript:deleteTestDefinition('" + handle + "', '" + name + "')", 
                   (canDelete == "true")));
            
            menu.addMenuItem(
                  new MenuItem(MenuItem.prototype.action,
                      "<%= request.getContextPath() %>/" + "<fmt:message key='application.createNew.image'/>", 
                      "<fmt:message key='application.createNewFrom.tooltip.txt'/>", 
                      "javascript:doAction('createNewFrom', '" + handle + "')",  
                      (canCreateTestDefinition == "true")));
          
            menu.render();
            return false;
         }
      
      </script>
            
   </mon:Head>
   <mon:Body>      
      <html:form action="/TestDefinitionsQuery">      
         <mon:ToolBar>
            <% if ( canCreateTestDefinition ) { %>
               <a class="toolBarAction" href="#" id="createTestDefinitionLink" onclick="createTestDefinition(); return false;"><fmt:message key='controlTesting.createTestDefinition.button.txt'/></a>
            <% } %>
            <mon:SavedView></mon:SavedView>
         </mon:ToolBar>
         
         <mon:Content>
              <input type="hidden" name="auditTestDef" value="<%= invokedInAuditTab %>" />
              <mon:tableComponent id="testDefinition" columnFormatters="<%= formatters %>" disableTableActions="true" >
               <mon:title><fmt:message key="controlTesting.TestDefinitionsQuery.title"/></mon:title>
               
               <%
                  TestDefinitionEx testDef = (TestDefinitionEx)pageContext.findAttribute("testDefinition");
                  if (testDef != null) {
                     boolean canDelete = testDef.canDelete(psession);
                     String name = ParsingUtils.escape(testDef.getTitleTxt());
                  
                     if (showContextMenu) { 
                %>
                  <mon:fixedColumn title='<%= bundle.getString("displayTable.actions.txt") %>' width="1%">
                     &nbsp;
                     <a href="#" onclick="return showContextMenu('<c:out value='${testDefinition.handleString}'/>', '<%= name %>', '<%= canCreateTestDefinitionGroup %>', '<%= canCreateTestDefinition %>', '<%= canDelete %>' )">
                     <img border="0"
                        src="<%= request.getContextPath() %>/<fmt:message key='application.showActionsButton.row.image'/>" 
                        alt="<fmt:message key='application.rowActions.tooltip.txt'/>"
                        title="<fmt:message key='application.rowActions.tooltip.txt'/>"
                     />
                     </a>
                     &nbsp;
                  </mon:fixedColumn>
               <%    } 
                     if (canCreateTest && !invokedInAuditTab.booleanValue()) { %>
                  <mon:fixedColumn before="false" title='<%= bundle.getString("controlTesting.createTests.title.txt") %>' width="1%">
                     <% if (testDef.canCreateTests(psession)){ %>
                        <a href="javascript:createTests('<c:out value="${testDefinition.handle}"/>') ">
                        <img border="0" src="<fmt:message key='application.createNew.image' />"  
                             alt="<fmt:message key='application.create.tooltip.txt'/>" 
                             title="<fmt:message key='application.create.tooltip.txt'/>"/>
                        </a>
                     <% } else { %>
                        &nbsp;
                     <% } %>
                  </mon:fixedColumn>
               <%    }
                  }
               %>
                     
           </mon:tableComponent>
         </mon:Content>   
         	<input type="hidden" name="auditTestDefinitions" value="<%=request.getAttribute(TestDefinitionsQueryAction.PARAM_AUDIT_TEST_DEFINITIONS) %>"/>
      </html:form>      
   </mon:Body>
</mon:Page>
